#pragma once
#include <memory>
#include <optional>
#include <string>
#include <vector>

#define INSTANCE_COPY_IMPL(CLASS_NAME) std::unique_ptr<Instance> CLASS_NAME::copy() { return std::make_unique<CLASS_NAME>(CLASS_NAME(*this)); } 

// The base class for all objects in the data model
class Instance : std::enable_shared_from_this<Instance> {
private:
    std::optional<std::weak_ptr<Instance>> Parent;
    std::vector<std::shared_ptr<Instance>> children;
public:
    std::string Name;
    std::optional<std::shared_ptr<Instance>> GetParent();
    void SetParent(std::optional<std::shared_ptr<Instance>> newParent);
    std::vector<std::shared_ptr<Instance>> GetChildren();

    virtual void Init();
    std::unique_ptr<Instance> CloneInternal();
    virtual std::unique_ptr<Instance> copy() const = 0;
};